#!/usr/bin/env python

# Inspire by Conbagui tutorial found here: http://fav.me/d91g0n9

# author: Pocholo
# date: 6/24/20

# Comments directed to http://gimpchat.com

# It create a 1600 X 712 yummy Caramel or a Chocolate text effect. Do not eat the text, please!
# Installation:
# This script should be placed in the user plugins folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.


from gimpfu import *

def pm_caramel_or_chocolate_text(customtext, font, caramel, chocolate):
		
	#Initiates the temporary state
	pdb.gimp_context_push()
		
	#Create a new image
	img = pdb.gimp_image_new(1, 1, RGB_IMAGE)
	
	#Variables
	width = img.width
	height = img.height
	
	if caramel:
		#Create the text
		pdb.gimp_context_set_foreground((32, 18, 0))
		layer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 100, 
											TRUE, 500, PIXELS, font)
		pdb.gimp_text_layer_set_justification(layer, 2)
		
		#Resize image
		img.resize(layer.width, layer.height, 0, 0)
		
		pdb.gimp_display_new(img)
						
		#Create a text copy
		non_empty = pdb.gimp_edit_copy(layer)
		copyLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Caramel copy", 85, LAYER_MODE_OVERLAY)
		pdb.gimp_image_add_layer(img, copyLayer, 0)
		pdb.gimp_layer_add_alpha(copyLayer)
		pdb.gimp_drawable_fill(copyLayer, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(copyLayer, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)
		pdb.gimp_image_set_active_layer(img, layer)
					
		#Create background
		backlayer = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, backlayer, 2)
		pdb.gimp_context_set_foreground((18, 6, 0))
		pdb.gimp_drawable_fill(backlayer, FILL_FOREGROUND)	
		
	
		
		#Create gradient for the background
		pdb.gimp_context_set_foreground((169, 117, 55))
		pdb.gimp_context_set_background((217, 185, 151))
		pdb.gimp_edit_blend(backlayer, 0, LAYER_MODE_NORMAL, 0, 100, 0, 0, FALSE, TRUE, 3, 0.20, TRUE, 0, 0, 0, 1400)
		
		
				
		#Create the effect 
		 
		#Drop Shadow
		pdb.python_layerfx_drop_shadow(img, layer, 
										(0, 0, 0),   #color
											   75,   #opacity
												0,   #contou-linear
												0,   #noise 
												3,   #mode for multiply 
												0,   #spread 
											   14,   #size 
											  130,   #offset_angle 
												10,   #offset_distance 
											 TRUE,   #knockout 
											FALSE)   #merge
		
		#Bevel and Emboss
		pdb.python_layerfx_bevel_emboss(img, layer, 
												 1,   #style inner bevel
												65,   #depth 
												 0,   #direction 
												10,   #size 
												16,   #soften
											   130,   #angle 
												35,   #altitude 
												 3,   #gloss_contour- gaussian 
								   (252, 207, 145),   #highlight_color 
												 4,   #highlight_mode lighten only
												55,   #highlight_opacity
										   "Black",   #shadow_color 
												 3,   #shadow_mode multyply
											   100,   #shadow_opacity 
												 6,   #surface_contour-half round 
											 FALSE,   #use_texture 
										"3D Green",   #pattern 
											   100,   #scale 
											   100,   #tex_depth 
											  TRUE,   #invert 
											 FALSE)   #merge

		#Color Overlay
		pdb.python_layerfx_color_overlay(img, layer, 
									   (152, 95, 0),  #color
												100,  #opacity
												  0,  #mode normal
											  FALSE)  #merge

		
		#Bevel and Emboss for the text copy
		pdb.gimp_image_set_active_layer(img, copyLayer)
		pdb.python_layerfx_bevel_emboss(img, copyLayer, 
													 1,   #style inner bevel
													65,   #depth 
													 0,   #direction 
													20,   #size 
													16,   #soften
												   130,   #angle 
													35,   #altitude 
													 3,   #gloss_contour- gaussian 
									   (252, 207, 145),   #highlight_color 
													 4,   #highlight_mode lighten only
													55,   #highlight_opacity
											   "Black",   #shadow_color 
													 3,   #shadow_mode multyply
												   100,   #shadow_opacity 
													 6,   #surface_contour-half round 
												 FALSE,   #use_texture 
											"3D Green",   #pattern 
												   100,   #scale 
												   100,   #tex_depth 
												  TRUE,   #invert 
												 FALSE)   #merge
											 
		
		pdb.gimp_context_set_foreground((111, 66, 0))
		pdb.gimp_image_select_item(img, 2, copyLayer)
		pdb.gimp_edit_bucket_fill(copyLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
		non_empty = pdb.gimp_edit_copy(copyLayer)
		copyLayer2 = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Caramel copy2", 85, LAYER_MODE_GRAIN_MERGE)
		pdb.gimp_image_add_layer(img, copyLayer2, 2)
		pdb.gimp_layer_add_alpha(copyLayer2)
		pdb.gimp_drawable_fill(copyLayer2, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(copyLayer2, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)
				
		pdb.gimp_layer_resize_to_image_size(layer)
		

	#Chocolate Text
	if chocolate:
		#Create the text
		pdb.gimp_context_set_foreground((12, 7, 0))
		layer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 70, 
											TRUE, 475, PIXELS, font)
		pdb.gimp_text_layer_set_justification(layer, 2)

		#Resize image
		img.resize(layer.width, layer.height, 0, 0)
				
		pdb.gimp_display_new(img)
		
		#Create a text copy
		non_empty = pdb.gimp_edit_copy(layer)
		copyLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Chocolate copy", 100, LAYER_MODE_MULTIPLY)
		pdb.gimp_image_add_layer(img, copyLayer, 0)
		pdb.gimp_layer_add_alpha(copyLayer)
		pdb.gimp_drawable_fill(copyLayer, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(copyLayer, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)
		pdb.gimp_image_set_active_layer(img, layer)
					
		#Create background
		backlayer = pdb.gimp_layer_new(img, layer.width, layer.height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, backlayer, 2)
		pdb.gimp_context_set_foreground((7, 4, 0))
		pdb.gimp_drawable_fill(backlayer, FILL_FOREGROUND)	
		
		
		
		#Create gradient for the background
		pdb.gimp_context_set_foreground((67, 34, 19))
		pdb.gimp_context_set_background((136, 83, 59))
		pdb.gimp_edit_blend(backlayer, 0, LAYER_MODE_NORMAL, 0, 100, 0, 0, FALSE, TRUE, 3, 0.20, TRUE, 0, 0, 0, 1400)
		
		
		#Create the effect 
		pdb.gimp_image_set_active_layer(img, layer) 
		
		#Drop Shadow
		pdb.python_layerfx_drop_shadow(img, layer, 
										(0, 0, 0),   #color
											 0.75,   #opacity
												0,   #contou-linear
												0,   #noise 
												3,   #mode for multiply 
												0,   #spread 
											   10,   #size 
											  130,   #offset_angle 
											   14,   #offset_distance 
											 TRUE,   #knockout 
											FALSE)   #merge
		
		#Bevel and Emboss 		
		pdb.python_layerfx_bevel_emboss(img, layer, 
												 1,   #style inner bevel
												65,   #depth 
												 0,   #direction 
												10,   #size 
												16,   #soften
											   130,   #angle 
												35,   #altitude 
												 3,   #gloss_contour- gaussian 
								   (252, 207, 145),   #highlight_color 
												 4,   #highlight_mode lighten only
												55,   #highlight_opacity
										   "Black",   #shadow_color 
												 3,   #shadow_mode multyply
											   100,   #shadow_opacity 
												 6,   #surface_contour-half round 
											 FALSE,   #use_texture 
										"3D Green",   #pattern 
											   100,   #scale 
											   100,   #tex_depth 
											  TRUE,   #invert 
											 FALSE)   #merge

		#Bevel and Emboss for the text copy
		pdb.gimp_image_set_active_layer(img, copyLayer)
		pdb.python_layerfx_bevel_emboss(img, copyLayer, 
													 1,   #style inner bevel
													65,   #depth 
													 0,   #direction 
													20,   #size 
													16,   #soften
												   130,   #angle 
													35,   #altitude 
													 3,   #gloss_contour- gaussian 
									   (252, 207, 145),   #highlight_color 
													 4,   #highlight_mode lighten only
													55,   #highlight_opacity
											   "Black",   #shadow_color 
													 3,   #shadow_mode multyply
												   100,   #shadow_opacity 
													 6,   #surface_contour-half round 
												 FALSE,   #use_texture 
											"3D Green",   #pattern 
												   100,   #scale 
												   100,   #tex_depth 
												  TRUE,   #invert 
												 FALSE)   #merge
											 		
		#Create chocolate color
		pdb.gimp_context_set_foreground((111, 66, 0))
		pdb.gimp_image_select_item(img, 2, copyLayer)
		pdb.gimp_edit_bucket_fill(copyLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
		pdb.gimp_selection_none(img)
										 		
		pdb.gimp_layer_resize_to_image_size(layer)
		
	#Resets the previous user defaults
	pdb.gimp_context_pop()

register(
	"pm_caramel_or_chocolate_text",
	"Creates a tasty Caramel or chocolate text",
	"Creates a tasty Caramel or chocolate text",
	"Pocholo",
	"Pocholo",
	"2020",
	"Caramel or Chocolate text",
	"",
[
	(PF_TEXT, "customtext", "Text string", 'Caramel\nText'),
    (PF_FONT, "font", "Font face", "ArTarumianGovazd Italic"),
	(PF_BOOL, "caramel", "Caramel Text", False),
    (PF_BOOL, "chocolate", "Chocolate Text", False),
],
[],
pm_caramel_or_chocolate_text, menu="<Image>/Pocholo-scripts/Caramel or Chocolate text")
main()